---
AWSTemplateFormatVersion: "2010-09-09"
Description: "Creates VPC and requested subnets including ACLs and Route tables"
Parameters:
  EnvironmentAbbr:
    Description          : "Stack Environment abbreviation"
    Type                 : "String"
  VPCName:
    Description          : "Name of the VPC."
    Type                 : "String"
  Network:
    Description          : "VPC's Network Range in CIDR format"
    Type                 : "String"
    AllowedPattern       : "(\\d{1,3})\\.(\\d{1,3})\\.(\\d{1,3})\\.(\\d{1,3})/(\\d{1,2})"
    ConstraintDescription: "Must be a valid network range of the form x.x.x.x/xx"

  CreateNatGateway:
    Description          : "Should we create a nat gateway (only applicable if private subnets are created)"
    Type                 : "String"
    AllowedValues        : ["True", "False"]
    ConstraintDescription: "Must be a either True or False"

  HaveAWSGateway:
    Description          : "Will you deploy a different gateway? This will still enable private->public routing."
    Type                 : "String"
    AllowedValues        : ["True", "False"]
    ConstraintDescription: "Must be a either True or False"

  DomainNames:
    Description          : "List of domain names that should be set in DHCP options"
    Type                 : "String"

Conditions:
  CreateNatGatewayCondition:
    Fn::Equals:
      - !Ref "CreateNatGateway"
      - "True"
  CnHaveAWSGateway:
    Fn::Equals:
      - !Ref "HaveAWSGateway"
      - "True"
  CnSomeGateway:
    Fn::Or:
      - !Condition "CreateNatGatewayCondition"
      - !Condition "CnHaveAWSGateway"

Resources:
  VPC:
    Type: "AWS::EC2::VPC"
    Properties:
      CidrBlock: !Sub "${Network}"
      InstanceTenancy: "default"
      EnableDnsSupport: True
      EnableDnsHostnames: True
      Tags:
        - Key: "Name"
          Value: !Sub "${EnvironmentAbbr}-${VPCName}"
  DHCPOptions:
    Type: "AWS::EC2::DHCPOptions"
    Properties:
      DomainName: !Ref DomainNames
      DomainNameServers:
        - "AmazonProvidedDNS"
      Tags:
        - Key: "Name"
          Value: !Sub "${EnvironmentAbbr}-${VPCName}"
  VPCDHCPOptionsAssociation:
    Type: "AWS::EC2::VPCDHCPOptionsAssociation"
    Properties:
      VpcId: !Ref "VPC"
      DhcpOptionsId: !Ref "DHCPOptions"

###########################################################################
#
#    Public network
#
###########################################################################
{% if (subnets.public | count | ternary(True, False)) %}
  InternetGateway:
    Type: "AWS::EC2::InternetGateway"
    Properties:
      Tags:
        - Key: "Name"
          Value: !Sub "${EnvironmentAbbr}-${VPCName}"
  InternetGatewayAttachement:
    Type: "AWS::EC2::VPCGatewayAttachment"
    Properties:
      InternetGatewayId: !Ref "InternetGateway"
      VpcId: !Ref "VPC"
  RouteTablePublic:
    Type: "AWS::EC2::RouteTable"
    Properties:
      VpcId: !Ref "VPC"
      Tags:
        - Key: "Name"
          Value: !Sub "${EnvironmentAbbr}-${VPCName}-Public"

  RoutePublic:
    Type: "AWS::EC2::Route"
    Properties:
      DestinationCidrBlock: "0.0.0.0/0"
      RouteTableId: !Ref "RouteTablePublic"
      GatewayId: !Ref "InternetGateway"
    DependsOn: "InternetGatewayAttachement"

  AclPublic:
    Type: "AWS::EC2::NetworkAcl"
    Properties:
      VpcId: !Ref "VPC"
      Tags:
        - Key: "Name"
          Value: !Sub "${EnvironmentAbbr}-${VPCName}-Public"
  AclOutPublic:
    Type: "AWS::EC2::NetworkAclEntry"
    Properties:
      CidrBlock: "0.0.0.0/0"
      Egress: True
      Protocol: -1
      RuleAction: "allow"
      RuleNumber: 10
      NetworkAclId: !Ref "AclPublic"
# Ephemeral ports TCP - see https://docs.aws.amazon.com/vpc/latest/userguide/vpc-network-acls.html#nacl-ephemeral-ports
  AclInPublicTCPEphemeral:
    Type: AWS::EC2::NetworkAclEntry
    Properties:
      RuleNumber: 10
      Egress: False
      Protocol: 6
      CidrBlock: "0.0.0.0/0"
      PortRange:
        From: 1024
        To: 65535
      RuleAction: "allow"
      NetworkAclId: !Ref "AclPublic"
# Ephemeral ports UDP - see https://docs.aws.amazon.com/vpc/latest/userguide/vpc-network-acls.html#nacl-ephemeral-ports
  AclInPublicUDPEphemeral:
    Type: AWS::EC2::NetworkAclEntry
    Properties:
      RuleNumber: 11
      Egress: False
      Protocol: 17
      CidrBlock: "0.0.0.0/0"
      PortRange:
        From: 1024
        To: 65535
      RuleAction: "allow"
      NetworkAclId: !Ref "AclPublic"

# Public subnets
{% for item in subnets.public %}
# Public subnet {{ loop.index }} - {{ item.az }} using {{ item.cidr }}
  SubnetPublic{{ loop.index }}:
    Type: "AWS::EC2::Subnet"
    Properties:
      CidrBlock: "{{ item.cidr }}"
      AvailabilityZone: "{{ item.az }}"
      VpcId: !Ref "VPC"
      Tags:
        - Key: "Name"
          Value: !Sub "${EnvironmentAbbr}-${VPCName}-Public-{{ item.az[-2:] }}"
  SubnetAclPublic{{ loop.index }}:
    Type: "AWS::EC2::SubnetNetworkAclAssociation"
    Properties:
      NetworkAclId: !Ref "AclPublic"
      SubnetId: !Ref "SubnetPublic{{ loop.index }}"
  SubnetRoutePublic{{ loop.index }}:
    Type: "AWS::EC2::SubnetRouteTableAssociation"
    Properties:
      RouteTableId: !Ref "RouteTablePublic"
      SubnetId: !Ref "SubnetPublic{{ loop.index }}"

{% endfor %}

{% else %}
# No public subnet defined - skipping.
{% endif %}

###########################################################################
#
#    Private network
#
###########################################################################
{% if (subnets.private | count | ternary(True, False)) %}
{% for item in subnets.private %}
# PrivateSubnet {{ loop.index }}
  RouteTablePrivate{{ loop.index }}:
    Type: "AWS::EC2::RouteTable"
    Properties:
      VpcId: !Ref "VPC"
      Tags:
        - Key: "Name"
          Value: !Sub "${EnvironmentAbbr}-${VPCName}-Private{{ loop.index }}"

# Private subnet {{ loop.index }} - {{ item.az }} using {{ item.cidr }}
  SubnetPrivate{{ loop.index }}:
    Type: "AWS::EC2::Subnet"
    Properties:
      CidrBlock: "{{ item.cidr }}"
      AvailabilityZone: "{{ item.az }}"
      VpcId: !Ref "VPC"
      Tags:
        - Key: "Name"
          Value: !Sub "${EnvironmentAbbr}-${VPCName}-Private-{{ item.az[-2:] }}"
  SubnetAclPrivate{{ loop.index }}:
    Type: "AWS::EC2::SubnetNetworkAclAssociation"
    Properties:
      NetworkAclId:
        Ref: "AclPrivate"
      SubnetId:
        Ref: "SubnetPrivate{{ loop.index }}"
  SubnetRoutePrivate{{ loop.index }}:
    Type: "AWS::EC2::SubnetRouteTableAssociation"
    Properties:
      RouteTableId: !Ref "RouteTablePrivate{{ loop.index }}"
      SubnetId: !Ref "SubnetPrivate{{ loop.index }}"

# Private to Public access for NAT gateway access
  VPCAclPublicIngressPrivate{{ loop.index }}:
    Type: AWS::EC2::NetworkAclEntry
    Condition: "CnSomeGateway"
    Properties:
      RuleNumber: 2{{ loop.index }}
      Egress: False
      Protocol: -1
      CidrBlock: "{{ item.cidr }}"
      RuleAction: allow
      NetworkAclId: !Ref "AclPublic"

{% endfor %}

  AclPrivate:
    Type: "AWS::EC2::NetworkAcl"
    Properties:
      VpcId: !Ref "VPC"
      Tags:
        - Key: "Name"
          Value: !Sub "${EnvironmentAbbr}-${VPCName}-Private"
  AclOutPrivateTCP:
    Type: "AWS::EC2::NetworkAclEntry"
    Properties:
      CidrBlock: "0.0.0.0/0"
      Egress: True
      Protocol: -1
      RuleAction: "allow"
      RuleNumber: 10
      NetworkAclId: !Ref "AclPrivate"
  AclInPrivateTCP:
    Type: "AWS::EC2::NetworkAclEntry"
    Properties:
      CidrBlock: !Ref "Network"
      Protocol: -1
      RuleAction: "allow"
      RuleNumber: 10
      NetworkAclId: !Ref "AclPrivate"

# Ephemeral ports TCP - see https://docs.aws.amazon.com/vpc/latest/userguide/vpc-network-acls.html#nacl-ephemeral-ports
  AclInPrivateTCPEphemeral:
    Type: AWS::EC2::NetworkAclEntry
    Properties:
      RuleNumber: 11
      Egress: False
      Protocol: 6
      CidrBlock: 0.0.0.0/0
      PortRange:
        From: 1024
        To: 65535
      RuleAction: allow
      NetworkAclId: !Ref "AclPrivate"
# Ephemeral ports UDP - see https://docs.aws.amazon.com/vpc/latest/userguide/vpc-network-acls.html#nacl-ephemeral-ports
  AclInPrivateUDPEphemeral:
    Type: AWS::EC2::NetworkAclEntry
    Properties:
      RuleNumber: 12
      Egress: False
      Protocol: 17
      CidrBlock: 0.0.0.0/0
      PortRange:
        From: 1024
        To: 65535
      RuleAction: allow
      NetworkAclId: !Ref "AclPrivate"

{% else %}
# No private subnet defined - skipping.
{% endif %}

###########################################################################
#
#    Database network
#
###########################################################################
{% if (subnets.db | count | ternary(True, False)) %}
{% for item in subnets.db %}
  RouteTableDatabase{{ loop.index }}:
    Type: "AWS::EC2::RouteTable"
    Properties:
      VpcId: !Ref "VPC"
      Tags:
        - Key: "Name"
          Value: !Sub "${EnvironmentAbbr}-${VPCName}-Database{{ loop.index }}"

# Database subnet {{ loop.index }} - {{ item.az }} using {{ item.cidr }}
  SubnetDatabase{{ loop.index }}:
    Type: "AWS::EC2::Subnet"
    Properties:
      CidrBlock: "{{ item.cidr }}"
      AvailabilityZone: "{{ item.az }}"
      VpcId: !Ref "VPC"
      Tags:
        - Key: "Name"
          Value: !Sub "${EnvironmentAbbr}-${VPCName}-Database-{{ item.az[-2:] }}"
  SubnetAclDatabase{{ loop.index }}:
    Type: "AWS::EC2::SubnetNetworkAclAssociation"
    Properties:
      NetworkAclId:
        Ref: "AclDatabase"
      SubnetId:
        Ref: "SubnetDatabase{{ loop.index }}"
  SubnetRouteDatabase{{ loop.index }}:
    Type: "AWS::EC2::SubnetRouteTableAssociation"
    Properties:
      RouteTableId: !Ref "RouteTableDatabase{{ loop.index }}"
      SubnetId: !Ref "SubnetDatabase{{ loop.index }}"

{% endfor %}

  AclDatabase:
    Type: "AWS::EC2::NetworkAcl"
    Properties:
      VpcId: !Ref "VPC"
      Tags:
        - Key: "Name"
          Value: !Sub "${EnvironmentAbbr}-${VPCName}-Database"
  AclOutDatabaseTCP:
    Type: "AWS::EC2::NetworkAclEntry"
    Properties:
      CidrBlock: "0.0.0.0/0"
      Egress: True
      Protocol: -1
      RuleAction: "allow"
      RuleNumber: 10
      NetworkAclId: !Ref "AclDatabase"
  AclInDatabaseTCP:
    Type: "AWS::EC2::NetworkAclEntry"
    Properties:
      CidrBlock: !Ref "Network"
      Protocol: -1
      RuleAction: "allow"
      RuleNumber: 10
      NetworkAclId: !Ref "AclDatabase"

# Ephemeral ports TCP - see https://docs.aws.amazon.com/vpc/latest/userguide/vpc-network-acls.html#nacl-ephemeral-ports
  AclInDatabaseTCPEphemeral:
    Type: AWS::EC2::NetworkAclEntry
    Properties:
      RuleNumber: 11
      Egress: False
      Protocol: 6
      CidrBlock: 0.0.0.0/0
      PortRange:
        From: 1024
        To: 65535
      RuleAction: allow
      NetworkAclId: !Ref "AclDatabase"
# Ephemeral ports UDP - see https://docs.aws.amazon.com/vpc/latest/userguide/vpc-network-acls.html#nacl-ephemeral-ports
  AclInDatabaseUDPEphemeral:
    Type: AWS::EC2::NetworkAclEntry
    Properties:
      RuleNumber: 12
      Egress: False
      Protocol: 17
      CidrBlock: 0.0.0.0/0
      PortRange:
        From: 1024
        To: 65535
      RuleAction: allow
      NetworkAclId: !Ref "AclDatabase"
 
{% else %}
# No database subnet defined - skipping.
{% endif %}
#################################################################
#
# NAT Gateway and routes for private and database subnets
# Resources will only be created if CreateNatGateway is True
# Only when public subnet is defined though...
#
# Note that the EIPs are not yet tagged since AWS fails on CFN
# once again: https://forums.aws.amazon.com/thread.jspa?threadID=96348
#################################################################
{% if (subnets.public | count | ternary(True, False)) %}
  NatGatewayIP1:
    Condition: "CreateNatGatewayCondition"
    Type: "AWS::EC2::EIP"
    DependsOn: "InternetGatewayAttachement"
    Properties:
      Domain: "vpc"
      # Tags:
      #   - Key  : "Name"
      #     Value: !Sub "${EnvironmentAbbr}-${VPCName}-ngw-eip-1"
  NatGateway1:
    Condition: "CreateNatGatewayCondition"
    Type: "AWS::EC2::NatGateway"
    DependsOn: "InternetGatewayAttachement"
    Properties:
      AllocationId: !GetAtt NatGatewayIP1.AllocationId
      SubnetId: !Ref "SubnetPublic1"
      Tags:
        - Key  : "Name"
          Value: !Sub "${EnvironmentAbbr}-${VPCName}-ngw-1"
  NatGatewayIP2:
    Condition: "CreateNatGatewayCondition"
    Type: "AWS::EC2::EIP"
    DependsOn: "InternetGatewayAttachement"
    Properties:
      Domain: "vpc"
      # Tags:
      #   - Key  : "Name"
      #     Value: !Sub "${EnvironmentAbbr}-${VPCName}-ngw-eip-2"
  NatGateway2:
    Condition: "CreateNatGatewayCondition"
    Type: "AWS::EC2::NatGateway"
    DependsOn: "InternetGatewayAttachement"
    Properties:
      AllocationId: !GetAtt NatGatewayIP2.AllocationId
      SubnetId: !Ref "SubnetPublic2"
      Tags:
        - Key  : "Name"
          Value: !Sub "${EnvironmentAbbr}-${VPCName}-ngw-1"

{% if (subnets.private | count | ternary(True, False)) %}
{% for item in subnets.private %}
  RoutePrivate{{ loop.index }}:
    Condition: "CreateNatGatewayCondition"
    Type: "AWS::EC2::Route"
    Properties:
      RouteTableId: !Ref "RouteTablePrivate{{ loop.index }}"
      DestinationCidrBlock: "0.0.0.0/0"
      NatGatewayId: !Ref "NatGateway{{ 1 if loop.index % 2 == 1 else 2 }}"
{% endfor %}
{% endif %}
{% if (subnets.db | count | ternary(True, False)) %}
{% for item in subnets.db %}
  RouteDatabase{{ loop.index }}:
    Condition: "CreateNatGatewayCondition"
    Type: "AWS::EC2::Route"
    Properties:
      RouteTableId: !Ref "RouteTableDatabase{{ loop.index }}"
      DestinationCidrBlock: "0.0.0.0/0"
      NatGatewayId: !Ref "NatGateway{{ 1 if loop.index % 2 == 1 else 2 }}"
{% endfor %}
{% endif %}
{% else %}
# No NAT gateway due to lacking public subnets. (thus it can't function)
{% endif %}

Outputs:
  VpcId:
    Value: !Ref "VPC"
    Description: "The VPC ID"
    Export:
      Name: !Sub "${AWS::StackName}-VpcId"
  VpcNetwork:
    Value: !GetAtt VPC.CidrBlock
    Description: "CIDR range of the VPC"
    Export:
      Name: !Sub "${AWS::StackName}-VpcNetwork"

  HasPrivateSubnets:
    Value: "{{ subnets.private | count | ternary('True', 'False') }}"
    Description: "True if the VPC has private subnets"
    Export:
      Name: !Sub "${AWS::StackName}-HasPrivateSubnets"
  HasDatabaseSubnets:
    Value: "{{ subnets.db | count | ternary('True', 'False') }}"
    Description: "True if the VPC has database subnets"
    Export:
      Name: !Sub "${AWS::StackName}-HasDatabaseSubnets"

{% if (subnets.private | count | ternary(True, False)) %}
  SubnetsPrivate:
    Description: "Private subnets for this VPC"
    Value: !Sub "{% for item in subnets.private %}${SubnetPrivate{{ loop.index }}}{% if not loop.last %},{% endif %}{% endfor %}"
    Export:
      Name: !Sub "${AWS::StackName}-SubnetsPrivate"
  RouteTablesPrivate:
    Description: "Private route tables for this VPC"
    Value: !Sub "{% for item in subnets.private %}${RouteTablePrivate{{ loop.index }}}{% if not loop.last %},{% endif %}{% endfor %}"
    Export:
      Name: !Sub "${AWS::StackName}-RouteTablesPrivate"
{% for item in subnets.private %}
  RouteTablePrivate{{ loop.index }}ID:
    Value: !Ref "RouteTablePrivate{{ loop.index }}"
    Export:
      Name: !Sub "${AWS::StackName}-RouteTablePrivate{{ loop.index }}ID"
  SubnetPrivateCIDR{{ loop.index }}:
    Value: "{{ item.cidr }}"
    Description: "CIDR block for this private subnet"
    Export:
      Name: !Sub "${AWS::StackName}-SubnetPrivateCIDR{{ loop.index }}"
{% endfor %}
{% endif %}

{% if (subnets.db | count | ternary(True, False)) %}
  SubnetsDatabase:
    Description: "Private database subnets for this VPC"
    Value: !Sub "{% for item in subnets.db %}${SubnetDatabase{{ loop.index }}}{% if not loop.last %},{% endif %}{% endfor %}"
    Export:
      Name: !Sub "${AWS::StackName}-SubnetsDatabase"
  RouteTablesDatabase:
    Description: "Private database route tables for this VPC"
    Value: !Sub "{% for item in subnets.db %}${RouteTableDatabase{{ loop.index }}}{% if not loop.last %},{% endif %}{% endfor %}"
    Export:
      Name: !Sub "${AWS::StackName}-RouteTablesDatabase"
{% for item in subnets.db %}
  RouteTableDatabase{{ loop.index }}ID:
    Value: !Ref "RouteTableDatabase{{ loop.index }}"
    Export:
      Name: !Sub "${AWS::StackName}-RouteTableDatabase{{ loop.index }}ID"
  SubnetDatabaseCIDR{{ loop.index }}:
    Value: "{{ item.cidr }}"
    Description: "CIDR block for this database subnet"
    Export:
      Name: !Sub "${AWS::StackName}-SubnetDatabaseCIDR{{ loop.index }}"
{% endfor %}
{% endif %}

{% if (subnets.public | count | ternary(True, False)) %}
  SubnetsPublic:
    Description: "Public subnets for this VPC"
    Value: !Sub "{% for item in subnets.public %}${SubnetPublic{{ loop.index }}}{% if not loop.last %},{% endif %}{% endfor %}"
    Export:
      Name: !Sub "${AWS::StackName}-SubnetsPublic"
{% for item in subnets.public %}
  SubnetPublicCIDR{{ loop.index }}:
    Value: "{{ item.cidr }}"
    Description: "CIDR block for this public subnet"
    Export:
      Name: !Sub "${AWS::StackName}-SubnetPublicCIDR{{ loop.index }}"
{% endfor %}
{% endif %}

{% if (subnets.private | count | ternary(True, False)) %}
  AclPrivateID:
    Value: !Ref "AclPrivate"
    Description: "AclPrivate for this VPC"
    Export:
      Name: !Sub "${AWS::StackName}-AclPrivateID"
{% endif %}
{% if (subnets.public | count | ternary(True, False)) %}
  AclPublicID:
    Value: !Ref "AclPublic"
    Description: "AclPublic for this VPC"
    Export:
      Name: !Sub "${AWS::StackName}-AclPublicID"
  RouteTablePublicID:
    Value: !Ref "RouteTablePublic"
    Export:
      Name: !Sub "${AWS::StackName}-RouteTablePublicID"
  NatGatewayIP1:
    Condition: "CreateNatGatewayCondition"
    Value: !Ref "NatGatewayIP1"
    Export:
      Name: !Sub "${AWS::StackName}-NatGatewayIP1"
  NatGatewayIP2:
    Condition: "CreateNatGatewayCondition"
    Value: !Ref "NatGatewayIP2"
    Export:
      Name: !Sub "${AWS::StackName}-NatGatewayIP2"
{% endif %}
{% if (subnets.db | count | ternary(True, False)) %}
  AclDatabaseID:
    Value: !Ref "AclDatabase"
    Description: "AclDatabase for this VPC"
    Export:
      Name: !Sub "${AWS::StackName}-AclDatabaseID"
{% endif %}
